'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Default element used for responding to actions in Rule or RuleGroup for the QueryBuilder
 */
var ActionElement = function ActionElement(props) {
  var label = props.label,
      className = props.className,
      handleOnClick = props.handleOnClick,
      title = props.title;

  return _react2.default.createElement(
    'button',
    { className: className,
      title: title,
      onClick: function onClick(e) {
        return handleOnClick(e);
      } },
    label
  );
};

ActionElement.displayName = 'ActionElement';

ActionElement.propTypes = {
  /**
   * text to appear for element
   */
  label: _propTypes2.default.string,
  /**
   *css classNames to be applied
   */
  className: _propTypes2.default.string,
  /**
   * callback function to invoke when element clicked
   */
  handleOnClick: _propTypes2.default.func,
  /**
   * html title
   */
  title: _propTypes2.default.string
};

exports.default = ActionElement;